The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Chorus Class Reference

STK chorus effect class. More...

`#include <Chorus.h>`

Inheritance diagram for stk::Chorus:

## Public Member Functions
| Chorus (StkFloat baseDelay=6000)
| Class constructor, taking the median desired delay length.
void | clear (void)
| Reset and clear all internal state.
void | setModDepth (StkFloat depth)
| Set modulation depth in range 0.0 - 1.0.
void | setModFrequency (StkFloat frequency)
| Set modulation frequency.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed stereo frame.
StkFloat | tick (StkFloat input, unsigned int channel=0)
| Input one sample to the effect and return the specified `channel` value of the computed stereo frame.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.
Public Member Functions inherited from stk::Effect
| Effect (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual void | clear ()=0
| Reset and clear all internal state.
virtual void | setEffectMix (StkFloat mix)
| Set the mixture of input and "effected" levels in the output (0.0 = input only, 1.0 = effect only).
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK chorus effect class.

This class implements a chorus effect. It takes a monophonic input signal and produces a stereo output signal.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ Chorus()

stk::Chorus::Chorus | ( | StkFloat | baseDelay = `6000` | ) |

Class constructor, taking the median desired delay length.

An StkError can be thrown if the rawwave path is incorrect.

## Member Function Documentation

## ◆ lastOut()

StkFloat stk::Chorus::lastOut | ( | unsigned int | channel = `0` | ) |
| inline

Return the specified channel value of the last computed stereo frame.

Use the lastFrame() function to get both values of the last computed stereo frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

94{
95#if defined(_STK_DEBUG_)
96 if ( channel > 1 ) {
97 oStream_ << "Chorus::lastOut(): channel argument must be less than 2!";
98 handleError( StkError::FUNCTION_ARGUMENT );
99 }
100#endif
101
102 return lastFrame_[channel];
103}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [1/3]

StkFloat stk::Chorus::tick | ( | StkFloat | input,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Input one sample to the effect and return the specified `channel` value of the computed stereo frame.

Use the lastFrame() function to get both values of the computed stereo output frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

106{
107#if defined(_STK_DEBUG_)
108 if ( channel > 1 ) {
109 oStream_ << "Chorus::tick(): channel argument must be less than 2!";
110 handleError( StkError::FUNCTION_ARGUMENT );
111 }
112#endif
113
114 delayLine_[0].setDelay( baseLength_ * 0.707 * ( 1.0 + modDepth_ * mods_[0].tick() ) );
115 delayLine_[1].setDelay( baseLength_ * 0.5 * ( 1.0 - modDepth_ * mods_[1].tick() ) );
116 lastFrame_[0] = effectMix_ * ( delayLine_[0].tick( input ) - input ) + input;
117 lastFrame_[1] = effectMix_ * ( delayLine_[1].tick( input ) - input ) + input;
118 return lastFrame_[channel];
119}
stk::Chorus::tick
StkFloat tick(StkFloat input, unsigned int channel=0)
Input one sample to the effect and return the specified channel value of the computed stereo frame.
Definition Chorus.h:105
stk::DelayL::tick
StkFloat tick(StkFloat input)
Input one sample to the filter and return one output.
Definition DelayL.h:163
stk::DelayL::setDelay
void setDelay(StkFloat delay)
Set the delay-line length.
Definition DelayL.h:136

## ◆ tick() [2/3]

StkFrames & stk::Chorus::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.

The StkFrames argument reference is returned. The stereo outputs are written to the StkFrames argument starting at the specified `channel`. Therefore, the `channel` argument must be less than ( channels() - 1 ) of the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

122{
123#if defined(_STK_DEBUG_)
124 if ( channel >= frames.channels() - 1 ) {
125 oStream_ << "Chorus::tick(): channel and StkFrames arguments are incompatible!";
126 handleError( StkError::FUNCTION_ARGUMENT );
127 }
128#endif
129
130 StkFloat *samples = &frames[channel];
131 unsigned int hop = frames.channels() - 1;
132 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
133 delayLine_[0].setDelay( baseLength_ * 0.707 * ( 1.0 + modDepth_ * mods_[0].tick() ) );
134 delayLine_[1].setDelay( baseLength_ * 0.5 * ( 1.0 - modDepth_ * mods_[1].tick() ) );
135 *samples = effectMix_ * ( delayLine_[0].tick( *samples ) - *samples ) + *samples;
136 samples++;
137 *samples = effectMix_ * ( delayLine_[1].tick( *samples ) - *samples ) + *samples;
138 }
139
140 lastFrame_[0] = *(samples-hop);
141 lastFrame_[1] = *(samples-hop+1);
142 return frames;
143}

## ◆ tick() [3/3]

StkFrames & stk::Chorus::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.

The `iFrames` object reference is returned. The `iChannel` argument must be less than the number of channels in the `iFrames` argument (the first channel is specified by 0). The `oChannel` argument must be less than ( channels() - 1 ) of the `oFrames` argument. However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

146{
147#if defined(_STK_DEBUG_)
148 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() - 1 ) {
149 oStream_ << "Chorus::tick(): channel and StkFrames arguments are incompatible!";
150 handleError( StkError::FUNCTION_ARGUMENT );
151 }
152#endif
153
154 StkFloat *iSamples = &iFrames[iChannel];
155 StkFloat *oSamples = &oFrames[oChannel];
156 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
157 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
158 delayLine_[0].setDelay( baseLength_ * 0.707 * ( 1.0 + modDepth_ * mods_[0].tick() ) );
159 delayLine_[1].setDelay( baseLength_ * 0.5 * ( 1.0 - modDepth_ * mods_[1].tick() ) );
160 *oSamples = effectMix_ * ( delayLine_[0].tick( *iSamples ) - *iSamples ) + *iSamples;
161 *(oSamples+1) = effectMix_ * ( delayLine_[1].tick( *iSamples ) - *iSamples ) + *iSamples;
162 }
163
164 lastFrame_[0] = *(oSamples-oHop);
165 lastFrame_[1] = *(oSamples-oHop+1);
166 return iFrames;
167}

The documentation for this class was generated from the following file:

- Chorus.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.